> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/api-reference/finpay-pg/snap/qris/generate-qr.md).

# Generate QR

### Technical Specification <a href="#technical-specification" id="technical-specification"></a>

| Environment | Method | URL                                                                 |
| ----------- | ------ | ------------------------------------------------------------------- |
| Development | POST   | <https://devo.finnet.co.id/pg/payment/card/v1.0/qr/qr-mpm-generate> |
| Production  | POST   | <https://live.finnet.co.id/pg/payment/card/v1.0/qr/qr-mpm-generate> |

### Body Request <a href="#body-request" id="body-request"></a>

| No | Name               | Type                                                                    | Mandatory | Min Length | Max Length | Description                                       |
| -- | ------------------ | ----------------------------------------------------------------------- | --------- | ---------- | ---------- | ------------------------------------------------- |
| 1  | partnerReferanceNo | String                                                                  | O         | 1          | 64         | Transaction identifier on service consumer system |
| 2  | amount             | [Object](/api-reference/appendix/json-object/amount-object.md)          | M         | 1          | 2          | Required, if qr\_type = 12                        |
| 3  | FeeAmount          | [Object](/api-reference/appendix/json-object/fee-amount-object.md)      | M         | 1          | 2          | Detail of Fee Amount                              |
| 4  | merchantId         | String                                                                  | M         | 1          | 64         | Merchant identifier, unique per each merchant     |
| 5  | subMerchantId      | String                                                                  | M         | 1          | 32         | Sub Merchant ID                                   |
| 6  | terminald          | String                                                                  | O         | 1          | 16         | Terminal identification                           |
| 7  | validityPeriod     | String                                                                  | M         | 1          | 25         | The time when the QRIS invalid                    |
| 8  | additionalInfo     | [Object](/api-reference/appendix/json-object/additional-info-object.md) | M         | 1          | 6          | Additional Info                                   |

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
   "partnerReferenceNo": "INV112024033108340012600007",
    "amount": {
        "value": "10000.00",
        "currency": "IDR"
    },
    "FeeAmount": {
        "value": "0.00",
        "currency": "IDR"
    },
    "merchantId": "FM2103300001",
    "subMerchantId": "FM2007160001",
    "terminalId": "213141251124",
    "validityPeriod": "2024-04-17T12:03:38-07:00",
    "additionalInfo": {
        "tipsIndikator": "00",
        "tipsFixamount": "0",
        "tipsPercentage": "0",
        "note": "",
        "qrType": "12",
        "callbackUrl": "https://demos.finnet.co.id/apiqrismerchanct/qr/callback-qris-static/index.php" 
   }
}
```

### Body Response <a href="#body-response" id="body-response"></a>

| No | Name               | Type                                                                    | Mandatory | Min Length | Max Length | Description                                                                                   |
| -- | ------------------ | ----------------------------------------------------------------------- | --------- | ---------- | ---------- | --------------------------------------------------------------------------------------------- |
| 1  | responseCode       | [Enum](/api-reference/appendix/enumeration/response-code-list.md)       | M         | 1          | 7          | BI SNAP Response Code.                                                                        |
| 2  | responseMessage    | String                                                                  | M         | 1          | 150        | BI SNAP Response Message.                                                                     |
| 3  | referenceNo        | String                                                                  | M         | 1          | 64         | Transaction identifier on service provider system. Must be filled upon successful transaction |
| 4  | partnerReferenceNo | String                                                                  | O         | 1          | 64         | Transaction identifier on service consumer system                                             |
| 5  | qrContent          | String                                                                  | M         | 1          | 512        | QR String MPM.                                                                                |
| 6  | merchantName       | String                                                                  | O         | 1          | 25         | Registered Merchant Name                                                                      |
| 7  | qrUrl              | String                                                                  | O         | 1          | 256        | QR URL for download QR Image                                                                  |
| 8  | terminalId         | String                                                                  | O         | 1          | 16         | Terminal Identification                                                                       |
| 9  | additionalInfo     | [Object](/api-reference/appendix/json-object/additional-info-object.md) | O         | 1          | 4          | Additional Info                                                                               |

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
   "responseCode":"2004700",
   "responseMessage":"Request has been processed successfully",
   "referenceNo":"weoOiX7RIjSBA31QGcUxrJLyaKFH0z5T",
   "partnerReferenceNo":"INV012021", 
   "qrContent":"00020101021226620013ID.FINPAY.WWW01189360077732007160010212FM20071600010303UKE51410014ID.CO.QRIS.WWW0212ID12345678910303UKE520458145303360540410005502025602505802ID5909Test Sogi6015JAKARTA SELATAN61051271062100706finnet630490FF",
   "merchantName":"Test Dapur",
   "qrUrl":"https://qrurl?img=12345",
   "terminalId":"213141251124",
   "additionalInfo":{
          "merchantId":"FM2103300001",
          "subMerchantId":"FM2007160001",
          "nmid":"123456612388",
          "validityPeriod": "2024-04-17T12:03:38-07:00"
   }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-pg/snap/qris/generate-qr.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
